#include "FTD2XX.h"

typedef FT_STATUS (WINAPI *PtrToOpen)(PVOID, FT_HANDLE *); 
PtrToOpen m_pOpen; 
FT_STATUS FTOpen(PVOID, FT_HANDLE *);

typedef FT_STATUS (WINAPI *PtrToOpenEx)(PVOID, DWORD, FT_HANDLE *); 
PtrToOpenEx m_pOpenEx; 
FT_STATUS FTOpenEx(PVOID, DWORD, FT_HANDLE *);

typedef FT_STATUS (WINAPI *PtrToListDevices)(PVOID, PVOID, DWORD);
PtrToListDevices m_pListDevices; 
FT_STATUS FTListDevices(PVOID, PVOID, DWORD);

typedef FT_STATUS (WINAPI *PtrToClose)(FT_HANDLE);
PtrToClose m_pClose;
FT_STATUS FTClose(FT_HANDLE);

typedef FT_STATUS (WINAPI *PtrToRead)(FT_HANDLE, LPVOID, DWORD, LPDWORD);
PtrToRead m_pRead;
FT_STATUS FTRead(FT_HANDLE, LPVOID, DWORD, LPDWORD);

typedef FT_STATUS (WINAPI *PtrToWrite)(FT_HANDLE, LPVOID, DWORD, LPDWORD);
PtrToWrite m_pWrite;
FT_STATUS FTWrite(FT_HANDLE, LPVOID, DWORD, LPDWORD);

typedef FT_STATUS (WINAPI *PtrToResetDevice)(FT_HANDLE);
PtrToResetDevice m_pResetDevice;
FT_STATUS FTResetDevice(FT_HANDLE);

typedef FT_STATUS (WINAPI *PtrToPurge)(FT_HANDLE, ULONG);
PtrToPurge m_pPurge;
FT_STATUS FTPurge(FT_HANDLE, ULONG);

typedef FT_STATUS (WINAPI *PtrToSetTimeouts)(FT_HANDLE, ULONG, ULONG);
PtrToSetTimeouts m_pSetTimeouts;
FT_STATUS FTSetTimeouts(FT_HANDLE, ULONG, ULONG);

typedef FT_STATUS (WINAPI *PtrToGetQueueStatus)(FT_HANDLE, LPDWORD);
PtrToGetQueueStatus m_pGetQueueStatus;
FT_STATUS FTGetQueueStatus(FT_HANDLE, LPDWORD);

typedef FT_STATUS (WINAPI *PtrToSetDtr)(FT_HANDLE);
PtrToSetDtr m_pSetDtr;
FT_STATUS FTSetDtr(FT_HANDLE);

typedef FT_STATUS (WINAPI *PtrToClrDtr)(FT_HANDLE);
PtrToClrDtr m_pClrDtr;
FT_STATUS FTClrDtr(FT_HANDLE);

typedef FT_STATUS (WINAPI *PtrToSetRts)(FT_HANDLE);
PtrToSetRts m_pSetRts;
FT_STATUS FTSetRts(FT_HANDLE);

typedef FT_STATUS (WINAPI *PtrToClrRts)(FT_HANDLE);
PtrToClrRts m_pClrRts;
FT_STATUS FTClrRts(FT_HANDLE);

typedef FT_STATUS (WINAPI *PtrToGetModemStatus)(FT_HANDLE, LPDWORD);
PtrToGetModemStatus m_pGetModemStatus;
FT_STATUS FTGetModemStatus(FT_HANDLE, LPDWORD);

typedef FT_STATUS (WINAPI *PtrToSetChars)(FT_HANDLE, UCHAR, UCHAR, UCHAR, UCHAR);
PtrToSetChars m_pSetChars;
FT_STATUS FTSetChars(FT_HANDLE, UCHAR, UCHAR, UCHAR, UCHAR);

typedef FT_STATUS (WINAPI *PtrToSetLatencyTimer)(FT_HANDLE, UCHAR);
PtrToSetLatencyTimer m_pSetLatencyTimer;
FT_STATUS FTSetLatencyTimer(FT_HANDLE, UCHAR);

typedef FT_STATUS (WINAPI *PtrToGetLatencyTimer)(FT_HANDLE, PUCHAR);
PtrToGetLatencyTimer m_pGetLatencyTimer;
FT_STATUS FTGetLatencyTimer(FT_HANDLE, PUCHAR);

typedef FT_STATUS (WINAPI *PtrToSetDataCharacteristics)(FT_HANDLE, UCHAR, UCHAR, UCHAR);
PtrToSetDataCharacteristics m_pSetDataCharacteristics;
FT_STATUS FTSetDataCharacteristics(FT_HANDLE, UCHAR, UCHAR, UCHAR);

typedef FT_STATUS (WINAPI *PtrToSetFlowControl)(FT_HANDLE, USHORT, UCHAR, UCHAR);
PtrToSetFlowControl m_pSetFlowControl;
FT_STATUS FTSetFlowControl(FT_HANDLE, USHORT, UCHAR, UCHAR);

typedef FT_STATUS (WINAPI *PtrToSetBreakOn)(FT_HANDLE);
PtrToSetBreakOn m_pSetBreakOn;
FT_STATUS FTSetBreakOn(FT_HANDLE);

typedef FT_STATUS (WINAPI *PtrToSetBreakOff)(FT_HANDLE);
PtrToSetBreakOff m_pSetBreakOff;
FT_STATUS FTSetBreakOff(FT_HANDLE);

typedef FT_STATUS (WINAPI *PtrToResetPort)(FT_HANDLE);
PtrToResetPort m_pResetPort;
FT_STATUS FTResetPort(FT_HANDLE);

typedef FT_STATUS (WINAPI *PtrToGetDeviceInfo)(FT_HANDLE, FT_DEVICE *, LPDWORD, PCHAR, PCHAR, LPVOID);
PtrToGetDeviceInfo m_pGetDeviceInfo;
FT_STATUS FTGetDeviceInfo(FT_HANDLE, FT_DEVICE *, LPDWORD, PCHAR, PCHAR, LPVOID);

typedef FT_STATUS (WINAPI *PtrToEE_UASize)(FT_HANDLE, LPDWORD);
PtrToEE_UASize m_pEE_UASize;
FT_STATUS FTEE_UASize(FT_HANDLE, LPDWORD);

typedef FT_STATUS (WINAPI *PtrToEE_UARead)(FT_HANDLE, PUCHAR, DWORD, LPDWORD);
PtrToEE_UARead m_pEE_UARead;
FT_STATUS FTEE_UARead(FT_HANDLE, PUCHAR, DWORD, LPDWORD);

typedef FT_STATUS (WINAPI *PtrToEE_UAWrite)(FT_HANDLE, PUCHAR, DWORD);
PtrToEE_UAWrite m_pEE_UAWrite;
FT_STATUS FTEE_UAWrite(FT_HANDLE, PUCHAR, DWORD);

typedef FT_STATUS (WINAPI *PtrToSetBitMode)(FT_HANDLE, UCHAR, UCHAR);
PtrToSetBitMode m_pSetBitMode;
FT_STATUS FTSetBitMode(FT_HANDLE, UCHAR, UCHAR);	

typedef FT_STATUS (WINAPI *PtrToGetBitMode)(FT_HANDLE, PUCHAR);
PtrToGetBitMode m_pGetBitMode;
FT_STATUS FTGetBitMode(FT_HANDLE, PUCHAR);

typedef FT_STATUS (WINAPI *PtrToSetEventNotification)(FT_HANDLE, DWORD, PVOID);
PtrToSetEventNotification m_pSetEventNotification;
FT_STATUS FTSetEventNotification(FT_HANDLE, DWORD, PVOID);

typedef FT_STATUS (WINAPI *PtrToGetStatus)(FT_HANDLE, LPDWORD, LPDWORD, LPDWORD);
PtrToGetStatus m_pGetStatus;
FT_STATUS FTGetStatus(FT_HANDLE, LPDWORD, LPDWORD, LPDWORD);	

typedef FT_STATUS (WINAPI *PtrToGetEventStatus)(FT_HANDLE, LPDWORD);
PtrToGetEventStatus m_pGetEventStatus;
FT_STATUS FTGetEventStatus(FT_HANDLE, LPDWORD);	

typedef FT_STATUS (WINAPI *PtrToSetBaudRate)(FT_HANDLE, DWORD);
PtrToSetBaudRate m_pSetBaudRate;
FT_STATUS FTSetBaudRate(FT_HANDLE, DWORD);
